use bitfield_struct::bitfield;

use crate::component_name;

use super::Component;

#[bitfield(u8)]
struct InterruptEntry {
  #[bits(4)]
  affinity: u8,
  masked: bool,
  fired: bool,
  #[bits(2)]
  _unused: u8,
}

pub struct InterruptController {
  _interrupt_entries: [InterruptEntry; 32],
}

impl Component for InterruptController {
  fn name() -> [u8; 0x30] {
    component_name!(b"interrupt_controller")
  }

  fn memory_map_size(&self) -> u64 {
    0
  }
}
