package ca.sanae.golemcomputers.blocks

import ca.sanae.golemcomputers.GolemComputers
import ca.sanae.golemcomputers.computer.Computer
import ca.sanae.golemcomputers.computer.components.ChatComponent
import net.fabricmc.api.EnvType
import net.fabricmc.api.Environment
import net.minecraft.block.BlockState
import net.minecraft.block.entity.BlockEntity
import net.minecraft.nbt.NbtCompound
import net.minecraft.registry.RegistryWrapper
import net.minecraft.util.math.BlockPos
import net.minecraft.world.World
import java.nio.channels.FileChannel
import kotlin.io.path.Path

class GolemBlockEntity(pos: BlockPos?, state: BlockState?) :
  BlockEntity(GolemComputers.GOLEM_BLOCK_ENTITY, pos, state) {
  private var computer: Computer? = null

  fun getClicks(): Int {
    return 0
  }

  fun incrementClicks() {
    markDirty()
  }

  override fun writeNbt(nbt: NbtCompound, registries: RegistryWrapper.WrapperLookup?) {
    nbt.putInt("clicks", 0)
    super.writeNbt(nbt, registries)
  }

  override fun readNbt(nbt: NbtCompound, registries: RegistryWrapper.WrapperLookup?) {
    nbt.getInt("clicks")
    super.readNbt(nbt, registries)
  }

  override fun setWorld(world: World?) {
    val path = Path("/home/aubrey/Projects/golem-software/assembly.bin")
    val channel = FileChannel.open(path);
    val buffer = channel.map(FileChannel.MapMode.READ_ONLY, 0, channel.size())
    if (!world!!.isClient) {
      val computer = Computer.Builder(world, buffer, 1u)
        .addChat(ChatComponent(world.server!!))
        .addCore(1000)
        .build()
      computer.resetCore(0, true);
      this.computer = computer;
    }
    super.setWorld(world)
  }

  fun tick() {
    computer?.tick()
  }
}