package ca.sanae.golemcomputers.computer

import java.io.File
import java.io.FileOutputStream
import java.lang.ref.Cleaner
import java.nio.channels.Channels


object RustNative {
  val cleaner: Cleaner = Cleaner.create()

  init {
    val nativeLibraryName = System.mapLibraryName("golem_computers")
    val tempFile: File = File.createTempFile("extracted_", nativeLibraryName)

    val classLoader = RustNative::class.java.getClassLoader()

    Channels.newChannel(classLoader.getResourceAsStream(nativeLibraryName)!!).use { src ->
      FileOutputStream(tempFile).channel.use { dst ->
        dst.transferFrom(src, 0, Long.MAX_VALUE)
      }
    }
    System.load(tempFile.absolutePath)
  }

  fun isInitialized(): Boolean {
    return true
  }
}